/* wzreg.v
   2019.5.10   Ver0.0
   Naoki Hirayama
*/
`timescale 1ns/1ps

`ifndef SPM_WIDTH
    `define SPM_WIDTH 7
`endif
//`define USE_XILINX_RAM_STYLE

module wzreg(CLK, xREGRA_P, xREGWA_P, xREGWE_P, xREGDI_P, xREGDO_P);
    input CLK;
    input [`SPM_WIDTH-1:0] xREGRA_P;
    input [`SPM_WIDTH-1:0] xREGWA_P;
    input xREGWE_P;
    input [7:0] xREGDI_P;
    output [7:0] xREGDO_P;

    reg [7:0] DO;

`ifdef USE_XILINX_RAM_STYLE
    (* ram_style = "block" *)
`endif
    reg [7:0] ram [2**`SPM_WIDTH-1:0];

`ifdef REG_INIT
    initial $readmemh("reg.mem", ram);
`endif

    always @(posedge CLK) begin
	DO <= ram [xREGRA_P];
        ram [xREGWA_P] <= xREGWE_P ? xREGDI_P : ram [xREGWA_P];
    end

    assign xREGDO_P = DO;

endmodule
