/* simwz.v
   2019.6.3    Ver0.0
   Naoki Hirayama
*/
`timescale 1ns/1ps

module simwz(
    input [8:0] SW,
    output [7:0] LED_A,  // OUTPORT
    output [7:0] LED_B,  // PORTID
    output [2:0] IOZ);

    reg CLK;
    reg xRESET_P;
    integer i;
    reg [7:0] inport;
    wire [7:0] port_id;

    assign LED_B = port_id;

    always @(posedge CLK) begin
        inport <= (port_id[1:0]==0) ? 8'h12 :
                  (port_id[1:0]==1) ? 8'h34 : 8'h56;
    end

    initial begin
`include "aesconst.v"
        CLK = 0;
        xRESET_P = 1;
        # 40
        xRESET_P = 0;
        # 20

        for(i=0 ; i<1000000000 ; i=i+1 ) begin
            # 10
            if( WZeta.WZctl.IR==8'hff && WZeta.WZctl.S==2'd1 ) begin
                $display("R0=%h R1=%h R2=%h R3=%h R4=%h R5=%h R6=%h R7=%h R8=%h R9=%h R10=%h R11=%h R12=%h R13=%h R14=%h R15=%h",
                         WZeta.WZreg.ram[0],
                         WZeta.WZreg.ram[1],
                         WZeta.WZreg.ram[2],
                         WZeta.WZreg.ram[3],
                         WZeta.WZreg.ram[4],
                         WZeta.WZreg.ram[5],
                         WZeta.WZreg.ram[6],
                         WZeta.WZreg.ram[7],
                         WZeta.WZreg.ram[8],
                         WZeta.WZreg.ram[9],
                         WZeta.WZreg.ram[10],
                         WZeta.WZreg.ram[11],
                         WZeta.WZreg.ram[12],
                         WZeta.WZreg.ram[13],
                         WZeta.WZreg.ram[14],
                         WZeta.WZreg.ram[15]);
                $finish;
            end
        end
        $display("TIME OVER");
        $finish;
    end

    always # 5 CLK <= ~CLK;

    wzeta WZeta(
        .CLK(CLK),
        .xINPORT_P(inport),
        .xRESET_P(xRESET_P),
	.xRSTROBE_P(IOZ[0]),
        .xWSTROBE_P(IOZ[1]),
`ifdef OP_OUTPUT2
        .xWSTROBE2_P(IOZ[2]),
`endif
        .xPORTID_P(port_id),
        .xOUTPORT_P(LED_A));
   
endmodule

