#!/usr/bin/perl
##########################################################
# WZeta Project https://wzeta.idletime.tokyo/
# Naoki Hirayama 2019/5/6
##########################################################

##### Optiopn #####
$fetch = 1;
$stack = 1;
##########################################################

$pass = 0;
$fail = 0;

sub dotest {
    if($tname eq '' || $check eq '') { die; }

    open(IN,"./wzsim S $tname.awz |");
    $flag = 0;
    while(<IN>) {
        if( /$check/ ) {$flag = 1;}
    }
    close(IN);
    if( $flag==1 ) {
        print "$tname ok!\n";
        $pass++;
    } else {
        print "$tname *** error ***\n";
        $fail++;
    }
}

##########################################################
@list = qw/R0=12 R0=06 R0=02 R0=02 R0=02 R0=02/;
for( $i = 1 ; $i<=6 ; $i++ ) {
    $tname = "opr$i";
    $check = shift( @list );
    &dotest;
}

##########################################################
@list = qw/R0=44 R0=44 R0=44 R0=0A/;
for( $i = 1 ; $i<=4 ; $i++ ) {
    $tname = "jump$i";
    $check = shift( @list );
    &dotest;
}

##########################################################
@list = qw/R0=44 R0=44 R0=55 R0=11/;
for( $i = 1 ; $i<=4 ; $i++ ) {
    $tname = "call$i";
    $check = shift( @list );
    &dotest;
}

##########################################################
@list = qw/R0=37 R0=79 R0=78 R0=FF/;
for( $i = 1 ; $i<=4 ; $i++ ) {
    $tname = "add$i";
    $check = shift( @list );
    &dotest;
}

##########################################################
@list = qw/R0=11 R0=12 R0=01/;
for( $i = 1 ; $i<=3 ; $i++ ) {
    $tname = "sub$i";
    $check = shift( @list );
    &dotest;
}

##########################################################
$tname = "andorxor";
$check = "R0=01";
&dotest;

##########################################################
$tname = "compare1";
$check = "R0=AA";
&dotest;

##########################################################
$tname = "compare2";
$check = "R0=AA";
&dotest;

##########################################################
$tname = "loadret";
$check = "R0=0F";
&dotest;

##########################################################
$tname = "address";
$check = "R0=FE";
&dotest;

##########################################################
$tname = "fetchstore";
$check = "R0=DE";
&dotest;

if($fetch==1) {
##########################################################
$tname = "aes1";
$check = "R0=8E";
&dotest;

##########################################################
$tname = "aes2";
$check = "R0=00";
&dotest;

##########################################################
$tname = "aes3";
$check = "R0=8E";
&dotest;

##########################################################
$tname = "encdec1";
$check = "R0=8E";
&dotest;

##########################################################
$tname = "encdec2";
$check = "R10=AA";
&dotest;

##########################################################
$tname = "encdec3";
$check = "R0=8E";
&dotest;

}

if($stack==1) {
##########################################################
$tname = "stack";
$check = "R0=88";
&dotest;
}

$total = $pass + $fail;
print "pass=$pass , fail=$fail , total=$total\n";
